<?xml version="1.0"?>
<xsl:stylesheet 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:qrz="http://online.qrz.com"
    version="1.0">

  <xsl:output method="xml" indent="yes" 
	      doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
	      doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" />

  <xsl:param name="callsign" />
  <xsl:variable name="key" />

  <xsl:template match="account">
    <xsl:variable name="mycall" select="callsign" />
    <xsl:variable name="password" select="password" />
    <xsl:variable name="loginurl" select="concat('http://online.qrz.com/bin/xml?', 'username=', $mycall, ';', 'password=', $password)" />
    <xsl:variable name="session" select="document($loginurl)" /> 
    <xsl:variable name="key" select="$session/qrz:QRZDatabase/qrz:Session/qrz:Key" />
    <xsl:variable name="url" select="concat('http://online.qrz.com/bin/xml?s=', $key, ';', 'callsign=', $callsign)" />
    <xsl:apply-templates select="document($url)" mode="QRZDatabase" />
  </xsl:template>

  <xsl:template match="/" mode="QRZDatabase">
    <xsl:text>&#10;</xsl:text>
    <html>
      <xsl:text>&#10;</xsl:text>
      <head>
	<title><xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:call"/></title>
	<style type="text/css">
	  .CallAndClass { color: green }
	  .NameAndEmail { color: red }
	  .CallAndClass, .NameAndEmail, .Website, .Address1, .Address2, .State, .Zip, .Land, .Grid { display: list-item} 
	</style>
	<script src="http://maps.google.com/maps?file=api&amp;v=1&amp;key=ABQIAAAATBHldoLTNmJHWBKgRE1MaxRBseHmELlIUptY_xd2PwbjkF3jOBSaZrMtcSrAHonO7NmtwHbhd7bt2A" type="text/javascript"></script>
    <script type="text/javascript">
   <xsl:comment>

     var map = null;
     function showQTH(longitude, latitude, msg) {
       var mylong = -122.114667;
       var mylat = 37.428833;
       showMap((longitude + mylong)/2, (latitude + mylat)/2, msg); // cheezy center
       var omqth = addMarker(longitude, latitude, msg);
       var myqth = addMarker(mylong, mylat, '');
       var points = [myqth, omqth];
       // not always the right sort
       points.sort(function(p1, p2) { return p1.x - p2.x; });
       map.addOverlay(new GPolyline(points));
     }

     function showMap(longitude, latitude, msg) {
       document.getElementById("map").style.width="500px";
       document.getElementById("map").style.height="400px";
       document.getElementById("map").style.display="block";
       map = new GMap(document.getElementById("map"));
       map.addControl(new GSmallMapControl());
       var omqth = new GPoint(longitude, latitude);
       map.centerAndZoom(omqth, 14);
     }


      // Creates a marker whose info window displays the given number
      function createMarker(point, msg) {
	var marker = new GMarker(point);

	// Show this marker's index in the info window when it is clicked
	var html = "QTH <b>" + msg + "</b>";
	GEvent.addListener(marker, "click", function() {
	  marker.openInfoWindowHtml(html);
	});

	return marker;
      }
  
      function addMarker(longitude, latitude, msg) {
	var point = new GPoint(longitude, latitude);
	var marker = createMarker(point, msg);
	map.addOverlay(marker);
	return point;
      }
      </xsl:comment>
    </script>
      </head>
      <xsl:text>&#10;</xsl:text>
      <body>
	<div>
	<h1 class="CallAndClass">
           <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:call" /><xsl:text> </xsl:text>
	   <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:class">
	     <xsl:text>(</xsl:text>
	     <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:class" /><xsl:text>)</xsl:text>
	   </xsl:if>
	  </h1>
	  <span class="NameAndEmail">
	    <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:fname" /><xsl:text> </xsl:text><xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:name" />
	    <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:email">
	      <xsl:text> &lt;</xsl:text>
	      <a>
		<xsl:attribute name="href" >
		  <xsl:text>mailto:</xsl:text>
		  <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:email" />
		</xsl:attribute>
		<xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:email" />
	      </a>
	      <xsl:text>&gt;</xsl:text>
	    </xsl:if>
	  </span>
          <span class="Website">
	    <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:url">
	      <xsl:variable name="url" select="qrz:QRZDatabase/qrz:Callsign/qrz:url" />
	      <a>
		<xsl:attribute name="href" >
		  <xsl:if test="not(starts-with($url, 'http'))">
		    <xsl:text>http://</xsl:text>
		  </xsl:if>
		  <xsl:value-of select="$url" />
		</xsl:attribute>
		<xsl:value-of select="$url" />
	      </a>
	    </xsl:if>
	  </span>
	  <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:addr1">
	    <span class="Address1">
	      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:addr1" /><xsl:text>&#10;</xsl:text>
	    </span>
	  </xsl:if>
	  <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:addr2">
	    <span class="Address2">
	      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:addr2" /><xsl:text> </xsl:text>
	    </span>
	  </xsl:if>
	  <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:state">
	    <span class="State">
	      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:state" /><xsl:text> </xsl:text>
	    </span>
	  </xsl:if>
	  <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:zip">
	    <span class="Zip">
	      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:zip" /><xsl:text> </xsl:text>
	    </span>
	  </xsl:if>
	  <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:land">
	    <span class="Land">
	      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:land" /><xsl:text>&#10;</xsl:text>
	    </span>
	  </xsl:if>
	  <span class="Grid">
	    <xsl:choose>
	      <xsl:when test="qrz:QRZDatabase/qrz:Callsign/qrz:grid">
		<a>
		  <xsl:if test="qrz:QRZDatabase/qrz:Callsign/qrz:latd != ''">
		    <xsl:attribute name="href">
		      <xsl:text>http://maps.google.com/maps?q=</xsl:text>
		      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:latd" />
		      <xsl:text>+</xsl:text>
		      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:lond" />
		    </xsl:attribute>
		  </xsl:if>
		  <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:grid" />
		</a>
		<xsl:text>&#10;</xsl:text>
		<a href="javascript:showQTH({qrz:QRZDatabase/qrz:Callsign/qrz:lond}, {qrz:QRZDatabase/qrz:Callsign/qrz:latd}, '{qrz:QRZDatabase/qrz:Callsign/qrz:call} {qrz:QRZDatabase/qrz:Callsign/qrz:grid}'); "><i>Map</i></a>
	      </xsl:when>
	      <xsl:otherwise>
		<xsl:apply-templates select="qrz:QRZDatabase/qrz:Callsign" mode="QRA" /> 
	      </xsl:otherwise>
	    </xsl:choose>
	  </span>
	</div>
	<div>
	  <img>
	    <xsl:attribute name="src" >
	      <xsl:value-of select="qrz:QRZDatabase/qrz:Callsign/qrz:image" />
	    </xsl:attribute>
	    </img>
	</div>
	<div id="map" style="display: none;"></div>
        <address><a href="{concat('http://www.qrz.com/callsign/',qrz:QRZDatabase/qrz:Callsign/qrz:call)}">QRZ.com</a> Premium Service</address>
	<xsl:call-template name="bio">
	  <xsl:with-param name="key" select="qrz:QRZDatabase/qrz:Session/qrz:Key" />
	</xsl:call-template>
      </body>
    </html>
  </xsl:template>
 
  <xsl:template name="bio">
    <xsl:param name="key" />
    <xsl:variable name="url2" select="concat('http://online.qrz.com/bin/xml?s=', $key, ';', 'bio=', $callsign)" />
    <xsl:apply-templates select="document($url2)" mode="bio" />
  </xsl:template>

  <xsl:template match="/" mode="bio">
    <xsl:if test="/qrz:QRZDatabase/qrz:Bio">
      <hr />
      <pre>
	<xsl:value-of select="/qrz:QRZDatabase/qrz:Bio/qrz:bio" />
      </pre> 
    </xsl:if>
  </xsl:template>

  <xsl:template match="qrz:Callsign" mode="QRA">
    <xsl:variable name="latd" select="qrz:latd + 90" />
    <xsl:variable name="lond" select="qrz:lond + 180" />
    <xsl:if test="qrz:latd and qrz:lond">
      <xsl:variable name="d1" select="substring('ABCDEFGHIJKLMNOPQRSTUVWXYZ', 1+floor($lond div 20.0), 1)" />
      <xsl:variable name="d2" select="substring('ABCDEFGHIJKLMNOPQRSTUVWXYZ', 1+floor($latd div 10.0), 1)" />
      <xsl:variable name="d3" select="floor(10*(($lond div 20.0) - floor($lond div 20.0)))" />
      <xsl:variable name="d4" select="floor(10*(($latd div 10.0) - floor($latd div 10.0)))" />
      <xsl:variable name="d5" select="substring('abcdefghijklmnopqrstuvwxyz', 1+floor(24*(($lond div 2.0)-floor($lond div 2.0))), 1)" />
      <xsl:variable name="d6" select="substring('abcdefghijklmnopqrstuvwxyz', 1+floor(24*($latd - floor($latd))), 1)" />
      <xsl:variable name="qra" select="concat($d1, $d2, $d3, $d4, $d5, $d6)" />
      <a>
	<xsl:attribute name="href">
	  <xsl:text>http://maps.google.com/maps?q=</xsl:text>
	  <xsl:value-of select="qrz:latd" />
	  <xsl:text>+</xsl:text>
	  <xsl:value-of select="qrz:lond" />
	</xsl:attribute>
	<xsl:value-of select="$qra" />
      </a>
      <xsl:text>&#10;</xsl:text>
      <a href="javascript:showQTH({qrz:lond}, {qrz:latd}, '{qrz:call} {$qra}');"><i>Map</i></a>
    </xsl:if>
  </xsl:template>

  <xsl:template match="text()|@*" />
</xsl:stylesheet>
